%Sletter alt fra minnet og laster inn lydhastigheter, 
%saltinnhold og temperatur.
clear all
clc
close all
%endelig;
%salt;
%temp;
bredde=100:100:10e3;
for k=1:length(bredde)
script_case1_january96;
M = frontsection;
%%

% Initsialisering av Lybin
lb=actxserver('LybinCom.LybinModelComBin');

% Initialiserer inputt-metoder
env = lb.invoke('IEnvironment'); % Milj (bunnprofile, bunntype, vindhastighet etc)
mod = lb.invoke('IModelData'); % Modellparametre (antall strler, cellestrrelser etc)
sensor = lb.invoke('ISensor'); % Sonarparametre (strlebredde, kildestyrke etc)
pulse = lb.invoke('IPuls'); % pulsegenskaper (bndbredde, pulslengde)
platform = lb.invoke('IPlatform'); % Platformegenskaper (egensty)
ocean = lb.invoke('IOcean'); % Havegenskaper (Ph, styniv)

% Setter inn sensordata
sensor.Depth = 40;
sensor.TiltReceiver = 0;
sensor.TiltTransmitter = 0;
sensor.SideLobeReceiver = 43;
sensor.SideLobeTransmitter = 43;
sensor.DetectionThreshold = 13;
sensor.Frequency = 1000;
sensor.DirectivityIndex = 25;
sensor.SourceLevel = 210;
sensor.BeamWidthReceiver = 10; % Vertikal strlebredde
sensor.BeamWidthTransmitter = 10; % Vertikal strlebredde

% Pulsegenskaper
pulse.Length = 1000; % i millisekund
pulse.FMBandWidth = 1000; % i Hz

% Modellegenskaper
R = 10000;
Z = 135;
R_cells = 100;
Z_cells = 34;
mod.SetRangeScaleAndRangeCells(R, R_cells); % Frste inputt er avstand og andre er antall rekkeviddeceller. De m settes sammen og ratioen m vre et heltall.
mod.SetRangeScaleAndRangeSteps(R, R_cells*10); % rekkevidde og steglengde. La steglengden typisk vre en tidel av cellestrrelsen
mod.TRLRays = 1000; % Antall strler. Bruk typisk mer enn 10 ganger antall rekkeviddeceller
mod.SetDepthScaleAndDepthCells(Z, Z_cells);% Frste inputt er dyp og andre er antall dybdeceller. De m settes sammen og ratioen m vre et heltall.
mod.SetDepthScaleAndDepthSteps(Z,Z_cells*10); % dybde og steglengde. La steglengden typisk vre en tidel av cellestrrelsen

% Mlstyrke
ocean.TargetStrength = 10; % Mlstyrken

% Laster inn lydhastighetstabell
%runs=100;

n=size(M,1); % depth
m=size(M,2); % range

%error10=zeros(1,runs-10);
%norm_error10=zeros(1,runs-10);
%error1=zeros(1,runs);
%norm_error1=zeros(1,runs);
%trl=zeros(Z_cells,R_cells,size(M,2));

    start=1;
    num_profiles=size(M,2);
    stop=size(M,2);
    % Avstandsvektor med grensene for hver blokk
    range = round(linspace(start,stop,num_profiles+1)); %legger til en grense. 
                                                        %25 blokker vil 
                                                        %f.eks kreve 26 grenser
    % Dybdevektor. Trenger ikke ha flere elmenter enn antall dybdeceller
    depth = round(linspace(1,135,34));
    
    % Lager k antall hastihetsprofiler (for hver blokk)
    spdprfl=zeros(length(depth),4,num_profiles);
    
    for i=1:num_profiles
        spdprfl(:,1,i)=depth;
        spdprfl(:,2,i)=7;
        spdprfl(:,3,i)=35;
        spdprfl(:,4,i)=M(depth,range(i));

    end

    % Skalerer opp til virkelig avstand og legger utvalget fra 1 - 10 km
    new_range=10*(range-1000);

    % Miljparametre
    env.WindSpeedMeasurment = [0,10000,0];
    
    % Legger hastighetsprofilene inn i modellen
    for j=1:num_profiles
        if j==1
            SetFirstSoundSpeedProfile(env,new_range(1), new_range(2),spdprfl(:,:,1))
        else    
            AddSoundSpeedProfile(env, new_range(j), new_range(j+1),spdprfl(:,:,j))
        end
    end
    env.BottomType = [0,5000,1;5000,10000,1]; 
    prof = [0,170;10000,170;];
    env.bottomProfile = prof; 
    env.AddBottomLossFan(0,0,[0,0;10,0; 90, 0]); 
    mod.UseMeasuredBottomLoss = 1; 

    % Kjrer LYBIN
    lb.DoCalculation

    % Henter data
    trl(:,:,k) = 10*log10(lb.GetResultsBin(0));
    
    
    %Beregner differansevektor
    if k==1
        error1(1,k)=0;
    else
        diff1=abs(trl(:,:,k)-trl(:,:,1));
        diff1_sum=sum(sum(diff1));
        error1(1,k)=diff1_sum/(R_cells*Z_cells);
    end
    

    k   
end

figure
plot(bredde,10*log10(error1))
xlabel('Bredde p front [m]')
ylabel('Gjennomsnittlig forskjell i hver celle, sammenlignet med celle 1')

% %savefig('konvergensraa3','pdf')
